/*******************************************************************************
 * Copyright (c) 2003, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.browser.StatusTextEvent;

import dwt.dwthelper.string;
import dwt.dwthelper.utils;
import dwt.events.TypedEvent;
import dwt.widgets.Widget;

/**
 * A <code>StatusTextEvent</code> is sent by a {@link Browser} to
 * {@link StatusTextListener}'s when the status text is changed.
 * The status text is typically displayed in the status bar of
 * a browser application.
 * 
 * @since 3.0
 */
public class StatusTextEvent : TypedEvent {
    /** status text */
    public String text;

    static const long serialVersionUID = 3258407348371600439L;

    this (Widget w) {
        super(w);
    }

    /**
     * Returns a String containing a concise, human-readable
     * description of the receiver.
     *
     * @return a String representation of the event
     */
    public String toString () {
        String String = super.toString();
        return String.substring(0, String.length() - 1) // remove trailing '}'
        + " text=" + text + "}";
    }
}
