/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSBrowserCell;

import dwt.internal.cocoa.NSCell;
import dwt.internal.cocoa.NSColor;
import dwt.internal.cocoa.NSImage;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSBrowserCell : NSCell
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSImage alternateImage ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_alternateImage);
        return result !is null ? new NSImage(result) : null;
    }

    public static NSImage branchImage ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSBrowserCell, OS.sel_branchImage);
        return result !is null ? new NSImage(result) : null;
    }

    public NSColor highlightColorInView (NSView controlView)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_highlightColorInView_1, controlView !is null ? controlView.id_ : null);
        return result !is null ? new NSColor(result) : null;
    }

    public static NSImage highlightedBranchImage ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSBrowserCell, OS.sel_highlightedBranchImage);
        return result !is null ? new NSImage(result) : null;
    }

    public NSImage image ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_image);
        return result !is null ? new NSImage(result) : null;
    }

    public bool isLeaf ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_isLeaf) !is null;
    }

    public bool isLoaded ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_isLoaded) !is null;
    }

    public void reset ()
    {
        OS.objc_msgSend(this.id_, OS.sel_reset);
    }

    public void set ()
    {
        OS.objc_msgSend(this.id_, OS.sel_set);
    }

    public void setAlternateImage (NSImage newAltImage)
    {
        OS.objc_msgSend(this.id_, OS.sel_setAlternateImage_1, newAltImage !is null ? newAltImage.id_ : null);
    }

    public void setImage (NSImage image)
    {
        OS.objc_msgSend(this.id_, OS.sel_setImage_1, image !is null ? image.id_ : null);
    }

    public void setLeaf (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setLeaf_1, flag);
    }

    public void setLoaded (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setLoaded_1, flag);
    }
}
