/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCachedImageRep;

import dwt.internal.cocoa.NSImageRep;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.NSSize;
import dwt.internal.cocoa.NSWindow;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCachedImageRep : NSImageRep
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSCachedImageRep initWithSize (NSSize size, objc.id depth, bool flag, bool alpha)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithSize_1depth_1separate_1alpha_1, size, depth, flag, alpha);
        return result !is null ? this : null;
    }

    public NSCachedImageRep initWithWindow (NSWindow win, NSRect rect)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithWindow_1rect_1, win !is null ? win.id_ : null, rect);
        return result !is null ? this : null;
    }

    public NSRect rect ()
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_rect);
        return result;
    }

    public NSWindow window ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_window);
        return result !is null ? new NSWindow(result) : null;
    }

}
