/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCollectionViewItem;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSCollectionView;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCollectionViewItem : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSCollectionView collectionView ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_collectionView);
        return result !is null ? new NSCollectionView(result) : null;
    }

    public bool isSelected ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_isSelected) !is null;
    }

    public id representedObject ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_representedObject);
        return result !is null ? new id(result) : null;
    }

    public void setRepresentedObject (id object)
    {
        OS.objc_msgSend(this.id_, OS.sel_setRepresentedObject_1, object !is null ? object.id_ : null);
    }

    public void setSelected (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setSelected_1, flag);
    }

    public void setView (NSView view)
    {
        OS.objc_msgSend(this.id_, OS.sel_setView_1, view !is null ? view.id_ : null);
    }

    public NSView view ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_view);
        return result !is null ? new NSView(result) : null;
    }

}
