/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSConditionLock;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSDate;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSConditionLock : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSInteger condition ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_condition);
    }

    public id initWithCondition (NSInteger condition)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithCondition_1, condition);
        return result !is null ? new id(result) : null;
    }

    public bool lockBeforeDate (NSDate limit)
    {
        return OS.objc_msgSend(this.id_, OS.sel_lockBeforeDate_1, limit !is null ? limit.id_ : null) !is null;
    }

    public void lockWhenCondition_ (NSInteger condition)
    {
        OS.objc_msgSend(this.id_, OS.sel_lockWhenCondition_1, condition);
    }

    public bool lockWhenCondition_beforeDate_ (NSInteger condition, NSDate limit)
    {
        return OS.objc_msgSend(this.id_, OS.sel_lockWhenCondition_1beforeDate_1, condition, limit !is null ? limit.id_ : null) !is null;
    }

    public NSString name ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_name);
        return result !is null ? new NSString(result) : null;
    }

    public void setName (NSString n)
    {
        OS.objc_msgSend(this.id_, OS.sel_setName_1, n !is null ? n.id_ : null);
    }

    public bool tryLock ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_tryLock) !is null;
    }

    public bool tryLockWhenCondition (NSInteger condition)
    {
        return OS.objc_msgSend(this.id_, OS.sel_tryLockWhenCondition_1, condition) !is null;
    }

    public void unlockWithCondition (NSInteger condition)
    {
        OS.objc_msgSend(this.id_, OS.sel_unlockWithCondition_1, condition);
    }

}
