/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDecimalNumberHandler;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDecimalNumberHandler : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public static id decimalNumberHandlerWithRoundingMode (objc.id roundingMode, short scale, bool exact, bool overflow, bool underflow,
            bool divideByZero)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSDecimalNumberHandler,
                OS.sel_decimalNumberHandlerWithRoundingMode_1scale_1raiseOnExactness_1raiseOnOverflow_1raiseOnUnderflow_1raiseOnDivideByZero_1,
                roundingMode, scale, exact, overflow, underflow, divideByZero);
        return result !is null ? new id(result) : null;
    }

    public static id defaultDecimalNumberHandler ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSDecimalNumberHandler, OS.sel_defaultDecimalNumberHandler);
        return result !is null ? new id(result) : null;
    }

    public id initWithRoundingMode (objc.id roundingMode, short scale, bool exact, bool overflow, bool underflow, bool divideByZero)
    {
        objc.id result = OS.objc_msgSend(this.id_,
                OS.sel_initWithRoundingMode_1scale_1raiseOnExactness_1raiseOnOverflow_1raiseOnUnderflow_1raiseOnDivideByZero_1, roundingMode, scale,
                exact, overflow, underflow, divideByZero);
        return result !is null ? new id(result) : null;
    }

}
