/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDeleteCommand;

import dwt.internal.cocoa.NSScriptCommand;
import dwt.internal.cocoa.NSScriptObjectSpecifier;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDeleteCommand : NSScriptCommand
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSScriptObjectSpecifier keySpecifier ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_keySpecifier);
        return result !is null ? new NSScriptObjectSpecifier(result) : null;
    }

    public void setReceiversSpecifier (NSScriptObjectSpecifier receiversRef)
    {
        OS.objc_msgSend(this.id_, OS.sel_setReceiversSpecifier_1, receiversRef !is null ? receiversRef.id_ : null);
    }

}
