/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDockTile;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSSize;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDockTile : NSObject
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSString badgeLabel ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_badgeLabel);
        return result !is null ? new NSString(result) : null;
    }

    public NSView contentView ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_contentView);
        return result !is null ? new NSView(result) : null;
    }

    public void display ()
    {
        OS.objc_msgSend(this.id_, OS.sel_display);
    }

    public id owner ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_owner);
        return result !is null ? new id(result) : null;
    }

    public void setBadgeLabel (NSString string)
    {
        OS.objc_msgSend(this.id_, OS.sel_setBadgeLabel_1, string !is null ? string.id_ : null);
    }

    public void setContentView (NSView view)
    {
        OS.objc_msgSend(this.id_, OS.sel_setContentView_1, view !is null ? view.id_ : null);
    }

    public void setShowsApplicationBadge (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setShowsApplicationBadge_1, flag);
    }

    public bool showsApplicationBadge ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_showsApplicationBadge) !is null;
    }

    public NSSize size ()
    {
        NSSize result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_size);
        return result;
    }
}
