/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMovie;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSPasteboard;
import dwt.internal.cocoa.NSURL;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMovie : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void* QTMovie ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_QTMovie);
    }

    public NSURL URL ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_URL);
        return result !is null ? new NSURL(result) : null;
    }

    public static bool canInitWithPasteboard (NSPasteboard pasteboard)
    {
        return OS.objc_msgSend(OS.class_NSMovie, OS.sel_canInitWithPasteboard_1, pasteboard !is null ? pasteboard.id_ : null) !is null;
    }

    public NSMovie initWithMovie (void* movie)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithMovie_1, movie);
        return result !is null ? this : null;
    }

    public NSMovie initWithPasteboard (NSPasteboard pasteboard)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithPasteboard_1, pasteboard !is null ? pasteboard.id_ : null);
        return result !is null ? this : null;
    }

    public NSMovie initWithURL (NSURL url, bool byRef)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithURL_1byReference_1, url !is null ? url.id_ : null, byRef);
        return result !is null ? this : null;
    }

    public static NSArray movieUnfilteredFileTypes ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSMovie, OS.sel_movieUnfilteredFileTypes);
        return result !is null ? new NSArray(result) : null;
    }

    public static NSArray movieUnfilteredPasteboardTypes ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSMovie, OS.sel_movieUnfilteredPasteboardTypes);
        return result !is null ? new NSArray(result) : null;
    }

}
