/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSNotification;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSNotification : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSString name ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_name);
        return result !is null ? new NSString(result) : null;
    }

    public static id static_notificationWithName_object_ (NSString aName, id anObject)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSNotification, OS.sel_notificationWithName_1object_1, aName !is null ? aName.id_ : null,
                anObject !is null ? anObject.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public static id static_notificationWithName_object_userInfo_ (NSString aName, id anObject, NSDictionary aUserInfo)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSNotification, OS.sel_notificationWithName_1object_1userInfo_1, aName !is null ? aName.id_ : null,
                anObject !is null ? anObject.id_ : null, aUserInfo !is null ? aUserInfo.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public id object ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_object);
        return result !is null ? new id(result) : null;
    }

    public NSDictionary userInfo ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_userInfo);
        return result !is null ? new NSDictionary(result) : null;
    }

}
