/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPortMessage;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSDate;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSPort;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPortMessage : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray components ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_components);
        return result !is null ? new NSArray(result) : null;
    }

    public NSPortMessage initWithSendPort (NSPort sendPort, NSPort replyPort, NSArray components)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithSendPort_1receivePort_1components_1, sendPort !is null ? sendPort.id_ : null,
                replyPort !is null ? replyPort.id_ : null, components !is null ? components.id_ : null);
        return result !is null ? this : null;
    }

    public uint msgid ()
    {
        return cast(uint) OS.objc_msgSend(this.id_, OS.sel_msgid);
    }

    public NSPort receivePort ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_receivePort);
        return result !is null ? new NSPort(result) : null;
    }

    public bool sendBeforeDate (NSDate date)
    {
        return OS.objc_msgSend(this.id_, OS.sel_sendBeforeDate_1, date !is null ? date.id_ : null) !is null;
    }

    public NSPort sendPort ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_sendPort);
        return result !is null ? new NSPort(result) : null;
    }

    public void setMsgid (uint msgid)
    {
        OS.objc_msgSend(this.id_, OS.sel_setMsgid_1, msgid);
    }

}
