/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPredicateEditor;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSRuleEditor;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPredicateEditor : NSRuleEditor
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray rowTemplates ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_rowTemplates);
        return result !is null ? new NSArray(result) : null;
    }

    public void setRowTemplates (NSArray rowTemplates)
    {
        OS.objc_msgSend(this.id_, OS.sel_setRowTemplates_1, rowTemplates !is null ? rowTemplates.id_ : null);
    }

}
