/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSScriptExecutionContext;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSScriptExecutionContext : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id objectBeingTested ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_objectBeingTested);
        return result !is null ? new id(result) : null;
    }

    public id rangeContainerObject ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_rangeContainerObject);
        return result !is null ? new id(result) : null;
    }

    public void setObjectBeingTested (id obj)
    {
        OS.objc_msgSend(this.id_, OS.sel_setObjectBeingTested_1, obj !is null ? obj.id_ : null);
    }

    public void setRangeContainerObject (id obj)
    {
        OS.objc_msgSend(this.id_, OS.sel_setRangeContainerObject_1, obj !is null ? obj.id_ : null);
    }

    public void setTopLevelObject (id obj)
    {
        OS.objc_msgSend(this.id_, OS.sel_setTopLevelObject_1, obj !is null ? obj.id_ : null);
    }

    public static NSScriptExecutionContext sharedScriptExecutionContext ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSScriptExecutionContext, OS.sel_sharedScriptExecutionContext);
        return result !is null ? new NSScriptExecutionContext(result) : null;
    }

    public id topLevelObject ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_topLevelObject);
        return result !is null ? new id(result) : null;
    }

}
