/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSecureTextFieldCell;

import dwt.internal.cocoa.NSTextFieldCell;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSSecureTextFieldCell : NSTextFieldCell
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool echosBullets ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_echosBullets) !is null;
    }

    public void setEchosBullets (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setEchosBullets_1, flag);
    }

}
