/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSpecifierTest;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSScriptObjectSpecifier;
import dwt.internal.cocoa.NSScriptWhoseTest;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;



enum NSTestComparisonOperation
{
    NSEqualToComparison = 0,
    NSLessThanOrEqualToComparison,
    NSLessThanComparison,
    NSGreaterThanOrEqualToComparison,
    NSGreaterThanComparison,
    NSBeginsWithComparison,
    NSEndsWithComparison,
    NSContainsComparison
}

alias NSTestComparisonOperation.NSEqualToComparison NSEqualToComparison;
alias NSTestComparisonOperation.NSLessThanOrEqualToComparison NSLessThanOrEqualToComparison;
alias NSTestComparisonOperation.NSLessThanComparison NSLessThanComparison;
alias NSTestComparisonOperation.NSGreaterThanOrEqualToComparison NSGreaterThanOrEqualToComparison;
alias NSTestComparisonOperation.NSGreaterThanComparison NSGreaterThanComparison;
alias NSTestComparisonOperation.NSBeginsWithComparison NSBeginsWithComparison;
alias NSTestComparisonOperation.NSEndsWithComparison NSEndsWithComparison;
alias NSTestComparisonOperation.NSContainsComparison NSContainsComparison;



public class NSSpecifierTest : NSScriptWhoseTest
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initWithObjectSpecifier (NSScriptObjectSpecifier obj1, NSTestComparisonOperation compOp, id obj2)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithObjectSpecifier_1comparisonOperator_1testObject_1, obj1 !is null ? obj1.id_ : null,
                compOp, obj2 !is null ? obj2.id_ : null);
        return result !is null ? new id(result) : null;
    }

}
